diff -urN dpkg-1.10.21.orig/main/archives.c dpkg-1.10.21/main/archives.c
--- dpkg-1.10.21.orig/main/archives.c	2012-07-13 02:12:44.000000000 +0200
+++ dpkg-1.10.21/main/archives.c	2012-07-13 02:13:27.000000000 +0200
@@ -553,12 +553,10 @@
     debug(dbg_eachfiledetail,"tarobject SymbolicLink creating");
 #ifdef HAVE_LCHOWN
     if (lchown(fnamenewvb.buf,
-#else
-    if (chown(fnamenewvb.buf,
-#endif
 	    nifd->namenode->statoverride ? nifd->namenode->statoverride->uid : ti->UserID,
 	    nifd->namenode->statoverride ? nifd->namenode->statoverride->gid : ti->GroupID))
       ohshite(_("error setting ownership of symlink `%.255s'"),ti->Name);
+#endif
     break;
   case Directory:
     /* We've already checked for an existing directory. */
@@ -614,10 +612,8 @@
         ohshite(_("unable to make backup symlink for `%.255s'"),ti->Name);
 #ifdef HAVE_LCHOWN
       if (lchown(fnametmpvb.buf,stab.st_uid,stab.st_gid))
-#else
-      if (chown(fnametmpvb.buf,stab.st_uid,stab.st_gid))
-#endif
         ohshite(_("unable to chown backup symlink for `%.255s'"),ti->Name);
+#endif
     } else {
       debug(dbg_eachfiledetail,"tarobject nondirectory, `link' backup");
       if (link(fnamevb.buf,fnametmpvb.buf))
diff -urN dpkg-1.10.21.orig/main/configure.c dpkg-1.10.21/main/configure.c
--- dpkg-1.10.21.orig/main/configure.c	2012-07-13 02:12:44.000000000 +0200
+++ dpkg-1.10.21/main/configure.c	2012-07-13 02:13:27.000000000 +0200
@@ -476,9 +476,10 @@
 static void suspend(void) {
 	const char*	s;
 	int		pid;
-
+#ifndef __APPLE__
 	s= getenv(NOJOBCTRLSTOPENV);
 	if (s && *s) {
+#endif
 		/* Do not job control to suspend but fork and start a new shell
 		 * instead.
 		 */
@@ -506,11 +507,13 @@
 			onerr_abort++;
 			ohshite(_("wait for shell failed"));
 		}
+#ifndef __APPLE__
 	} else {
 		fputs(_("Don't forget to foreground (`fg') this "
 					"process when you're done !\n"), stderr);
 		kill(-getpgid(0),SIGTSTP);
 	}
+#endif
 }
 
 
diff -urN dpkg-1.10.21.orig/main/enquiry.c dpkg-1.10.21/main/enquiry.c
--- dpkg-1.10.21.orig/main/enquiry.c	2012-07-13 02:12:44.000000000 +0200
+++ dpkg-1.10.21/main/enquiry.c	2012-07-13 02:13:27.000000000 +0200
@@ -402,7 +402,7 @@
   FILE *ccpipe;
   struct varbuf vb;
   ptrdiff_t ll;
-  char *p, *q;
+  char *p;
 
   if (*argv) badusage(_("--print-architecture does not take any argument"));
 
@@ -445,7 +445,7 @@
   default: internerr("unknown action in printarch");
   }
   if (!arch) {
-    *q= 0; arch= p;
+    arch= p;
     fprintf(stderr, _("dpkg: warning, architecture `%s' not in remapping table\n"),arch);
   }
   if (printf("%s\n",arch) == EOF) werr("stdout");
diff -urN dpkg-1.10.21.orig/main/filesdb.c dpkg-1.10.21/main/filesdb.c
--- dpkg-1.10.21.orig/main/filesdb.c	2012-07-13 02:12:44.000000000 +0200
+++ dpkg-1.10.21/main/filesdb.c	2012-07-13 02:13:27.000000000 +0200
@@ -25,6 +25,7 @@
 #include <unistd.h>
 #include <fcntl.h>
 #include <string.h>
+#include <ctype.h>
 #include <errno.h>
 #include <sys/stat.h>
 
@@ -566,7 +567,7 @@
 
 static int hash(const char *name) {
   int v= 0;
-  while (*name) { v *= 1787; v += *name; name++; }
+  while (*name) { v *= 1787; v += tolower(*name); name++; }
   return v;
 }
 
@@ -581,7 +582,7 @@
   while (*pointerp) {
 /* Why is this assert nescessary?  It is checking already added entries. */
     assert((*pointerp)->name[0] == '/');
-    if (!strcmp((*pointerp)->name+1,name)) break;
+    if (!strcasecmp((*pointerp)->name+1,name)) break;
     pointerp= &(*pointerp)->next;
   }
   if (*pointerp) return *pointerp;
diff -urN dpkg-1.10.21.orig/main/help.c dpkg-1.10.21/main/help.c
--- dpkg-1.10.21.orig/main/help.c	2012-07-13 02:12:44.000000000 +0200
+++ dpkg-1.10.21/main/help.c	2012-07-13 02:13:27.000000000 +0200
@@ -69,11 +69,18 @@
 
 void checkpath(void) {
 /* Verify that some programs can be found in the PATH. */
-  static const char *const checklist[]= { "ldconfig", 
+  static const char *const checklist[]= { 
+#ifndef __APPLE__
+    "ldconfig", 
+#endif
 #ifdef USE_START_STOP_DAEMON
     "start-stop-daemon",
 #endif    
-    "install-info", "update-rc.d", 0
+    "install-info",
+#ifndef __APPLE__
+   "update-rc.d",
+#endif
+    0
   };
 
   struct stat stab;
@@ -180,7 +187,7 @@
   }
   if (f_debug & dbg_scripts) {
     fprintf(stderr,"D0%05o: fork/exec %s (",dbg_scripts,path);
-    while (*argv) fprintf(stderr," %s",*argv++);
+    while (*++argv) fprintf(stderr," %s",*argv);
     fputs(" )\n",stderr);
   }
   instdirl= strlen(instdir);
@@ -256,17 +263,75 @@
 static int do_script(const char *pkg, const char *scriptname, const char *scriptpath, struct stat *stab, char *const arglist[], const char *desc, const char *name, int warn) {
   const char *scriptexec;
   int c1, r;
+  if (scriptpath) // if NULL, just want wrapper side-effect, no actual .deb script present
   setexecute(scriptpath,stab);
 
   c1= m_fork();
   if (!c1) {
     const char **narglist;
+    /* FINK LOCAL begin */
+    const char **full_narglist;
+    char *path_wrapper;
+    struct stat stab_wrapper;
+    const char *null_script_path = "";  // must be blank string (NULL is end-of-array sentinel)
+    /* FINK LOCAL end */
     for (r=0; arglist[r]; r++) ;
-    narglist=nfmalloc((r+1)*sizeof(char*));
+    // narglist=nfmalloc((r+1)*sizeof(char*));
+    /* FINK LOCAL begin */
+    full_narglist=nfmalloc((r+2)*sizeof(char*));  // leave space for wrapper-script-name, add NULL terminator
+    narglist=full_narglist+1;  // orig pointer points to orig array
+    /* FINK LOCAL end */
     for (r=1; arglist[r-1]; r++)
       narglist[r]= arglist[r];
+    if (scriptpath) { // FINK LOCAL
     scriptexec= preexecscript(scriptpath,narglist);
+    } else { scriptexec = null_script_path; }; // FINK LOCAL was called with no actual script path to run
     narglist[0]= scriptexec;
+    /* FINK LOCAL begin */
+    // try to set up with wrapper
+#define FINK_DPKG_SCRIPT_DIR "@PREFIX@/lib/fink/dpkg-base-files"
+    // determine wrapper-script pathname
+    asprintf(&path_wrapper, "%s/%s", FINK_DPKG_SCRIPT_DIR, scriptname);
+    if (path_wrapper == NULL) {
+      ohshite(_("dpkg - error: could not allocate for fink script wrapper for %s.\n"), scriptpath);
+    } else {
+      if (!stat(path_wrapper, &stab_wrapper)) {
+	if ((stab_wrapper.st_mode & 0555) == 0555) {
+	  // only use it if it exists and is chmod a+rx
+	  debug(dbg_scripts,"Wrapper script '%s' will be used around '%s'", path_wrapper, scriptpath);
+	  // it's good! set wrapper as actual runnable thing in narglist array
+	  narglist=full_narglist;
+	  scriptexec= preexecscript(path_wrapper,narglist);
+	  narglist[0]= scriptexec;
+
+	  /*
+	    Global wrapper needs way to introspect name of package
+	    being manipulated. Normal .deb scripts could have this
+	    hard-coded in their script because this info is known at
+	    the time the .deb is constructed. Pass the name as an
+	    env var to the wrapper.
+	  */
+	  setenv("FINK_PACKAGE_NAME", pkg, 1);
+	} else {
+	  debug(dbg_scripts,"Wrapper script '%s' wrong perms", path_wrapper);
+	  if (scriptpath) {
+	    debug(dbg_scripts,"...falling back to real script '%s'", scriptpath);
+	  } else {
+	    debug(dbg_scripts,"...skipping over because no real script '%s'", scriptpath);
+	    exit(0);
+	  }
+	}
+      } else {
+	debug(dbg_scripts,"Wrapper script '%s' does not exist", path_wrapper);
+	if (scriptpath) {
+	  debug(dbg_scripts,"...falling back to real script '%s'", scriptpath);
+	} else {
+	  debug(dbg_scripts,"...skipping over because no real script '%s'", scriptpath);
+	  exit(0);
+	}
+      }
+    }
+    /* FINK LOCAL end */
     execv(scriptexec,narglist);
     ohshite(desc,name);
   }
@@ -294,8 +359,13 @@
   if (stat(scriptpath,&stab)) {
     if (errno == ENOENT) {
       debug(dbg_scripts,"maintainer_script_installed nonexistent %s",scriptname);
-      return 0;
-    }
+//    return 0;
+      /* FINK LOCAL begin */
+      // always call do_script (fink adds side-effects), but pass NULL if no actual script
+      scriptpath = NULL;
+//  }
+    } else
+      /* FINK LOCAL end */
     ohshite(_("unable to stat installed %s script `%.250s'"),description,scriptpath);
   }
   do_script(pkg->name, scriptname, scriptpath, &stab, arglist, _("unable to execute %s"), buf, 0);
@@ -320,8 +390,14 @@
   if (stat(cidir,&stab)) {
     if (errno == ENOENT) {
       debug(dbg_scripts,"maintainer_script_new nonexistent %s `%s'",scriptname,cidir);
-      return 0;
-    }
+//    return 0;
+      //    }
+      /* FINK LOCAL begin */
+      // always call do_script (fink adds side-effects), but pass NULL if no actual script
+      cidir = NULL;
+//  }
+    } else
+      /* FINK LOCAL end */
     ohshite(_("unable to stat new %s script `%.250s'"),description,cidir);
   }
   do_script(pkgname, scriptname, cidir, &stab, arglist, _("unable to execute new %s"), buf, 0);
@@ -348,16 +424,19 @@
     if (errno == ENOENT) {
       debug(dbg_scripts,"maintainer_script_alternative nonexistent %s `%s'",
             scriptname,oldscriptpath);
-      return 0;
-    }
+      /* FINK LOCAL begin */
+      // always call do_script (fink adds side-effects), but pass NULL if no actual script
+      oldscriptpath = NULL;
+    } else {
+      /* FINK LOCAL end */
     fprintf(stderr,
             _("dpkg: warning - unable to stat %s `%.250s': %s\n"),
             buf,oldscriptpath,strerror(errno));
-  } else {
+    }
+  }
     if (!do_script(pkg->name, scriptname, oldscriptpath, &stab, arglist, _("unable to execute %s"), buf, PROCWARN))
       return 1;
     ensure_diversions();
-  }
   fprintf(stderr, _("dpkg - trying script from the new package instead ...\n"));
 
   arglist= buildarglist(scriptname,
@@ -367,6 +446,9 @@
   strcpy(cidirrest,scriptname);
   sprintf(buf,_("new %s script"),description);
 
+  // FINK if old-pkg fails, don't want to allow "success" of new
+  // solely because wrapper worked in new-pkg: loses important
+  // error-state that *should* fail loudly
   if (stat(cidir,&stab)) {
     if (errno == ENOENT)
       ohshit(_("there is no script in the new version of the package - giving up"));
@@ -410,6 +492,26 @@
     
   debug(dbg_veryverbose, "isdirectoryinuse `%s' (except %s)", file->name,
         pkg ? pkg->name : "<none>");
+
+  /* FINK LOCAL begin */
+
+  /*
+   * Darwin has symlinks /etc -> /private/etc and /var -> /private/var
+   * instead of actual /etc and /var dirs. If dpkg removes the last
+   * pkg that it has record of having installed a file in one of those
+   * top-level dirs, it will try to remove the dir (since it thinks
+   * it's an empty dir) and it will succeed (since it's just unlinking
+   * a symlink, not trying to remove a dir that is not actually
+   * empty). That's Bad. Here we make sure these top-level dirs are
+   * never thought to be empty.
+   */
+  if( !strcmp(file->name,"/etc") || !strcmp(file->name,"/tmp") || !strcmp(file->name,"/var") ) {
+    debug(dbg_veryverbose, "isdirectoryinuse precious!");
+    return 1;
+  }
+
+  /* FINK LOCAL end */
+
   for (packageslump= file->packages; packageslump; packageslump= packageslump->more) {
     debug(dbg_veryverbose, "isdirectoryinuse packageslump %s ...",
           packageslump->pkgs[0] ? packageslump->pkgs[0]->name : "<none>");
diff -urN dpkg-1.10.21.orig/main/help.c.orig dpkg-1.10.21/main/help.c.orig
--- dpkg-1.10.21.orig/main/help.c.orig	1970-01-01 01:00:00.000000000 +0100
+++ dpkg-1.10.21/main/help.c.orig	2012-07-13 02:13:27.000000000 +0200
@@ -0,0 +1,508 @@
+/*
+ * dpkg - main program for package management
+ * help.c - various helper routines
+ *
+ * Copyright (C) 1995 Ian Jackson <ian@chiark.greenend.org.uk>
+ *
+ * This is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2,
+ * or (at your option) any later version.
+ *
+ * This is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public
+ * License along with dpkg; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+#include <config.h>
+
+#include <errno.h>
+#include <unistd.h>
+#include <dirent.h>
+#include <assert.h>
+#include <string.h>
+#include <sys/stat.h>
+#include <sys/types.h>
+#include <sys/wait.h>
+#include <signal.h>
+
+#include <dpkg.h>
+#include <version.h>
+#include <dpkg-db.h>
+
+#include "filesdb.h"
+#include "main.h"
+
+const char *const statusstrings[]= {
+  N_("not installed"),
+  N_("unpacked but not configured"),
+  N_("broken due to postinst failure"),
+  N_("installed"),
+  N_("broken due to failed removal"),
+  N_("not installed but configs remain")
+};
+
+struct filenamenode *namenodetouse(struct filenamenode *namenode, struct pkginfo *pkg) {
+  struct filenamenode *r;
+  
+  if (!namenode->divert) return namenode;
+  
+  debug(dbg_eachfile,"namenodetouse namenode=`%s' pkg=%s",
+        namenode->name,pkg->name);
+  
+  r=
+    (namenode->divert->useinstead && namenode->divert->pkg != pkg)
+      ? namenode->divert->useinstead : namenode;
+  
+  debug(dbg_eachfile,
+        "namenodetouse ... useinstead=%s camefrom=%s pkg=%s return %s",
+        namenode->divert->useinstead ? namenode->divert->useinstead->name : "<none>",
+        namenode->divert->camefrom ? namenode->divert->camefrom->name : "<none>",
+        namenode->divert->pkg ? namenode->divert->pkg->name : "<none>",
+        r->name);
+  return r;
+}
+
+void checkpath(void) {
+/* Verify that some programs can be found in the PATH. */
+  static const char *const checklist[]= { 
+#ifndef __APPLE__
+    "ldconfig", 
+#endif
+#ifdef USE_START_STOP_DAEMON
+    "start-stop-daemon",
+#endif    
+    "install-info",
+#ifndef __APPLE__
+   "update-rc.d",
+#endif
+    0
+  };
+
+  struct stat stab;
+  const char *const *clp;
+  const char *path, *s, *p;
+  char* buf;
+  int warned= 0;
+  long l;
+
+  path= getenv("PATH");
+  if (!path) ohshit(_("dpkg - error: PATH is not set.\n"));
+  buf=(char*)m_malloc(strlen(path)+2+strlen("start-stop-daemon"));
+  
+  for (clp=checklist; *clp; clp++) {
+    s= path;
+    while (s) {
+      p= strchr(s,':');
+      l= p ? p-s : (long)strlen(s);
+      memcpy(buf,s,l);
+      if (l) buf[l++]= '/';
+      strcpy(buf+l,*clp);
+      if (stat(buf,&stab) == 0 && (stab.st_mode & 0111)) break;
+      s= p; if (s) s++;
+    }
+    if (!s) {
+      fprintf(stderr,_("dpkg: `%s' not found on PATH.\n"),*clp);
+      warned++;
+    }
+  }
+
+  free(buf);
+  if (warned)
+    forcibleerr(fc_badpath,_("%d expected program(s) not found on PATH.\nNB: root's "
+                "PATH should usually contain /usr/local/sbin, /usr/sbin and /sbin."),
+                warned);
+}
+
+void ensure_package_clientdata(struct pkginfo *pkg) {
+  if (pkg->clientdata) return;
+  pkg->clientdata= nfmalloc(sizeof(struct perpackagestate));
+  pkg->clientdata->istobe= itb_normal;
+  pkg->clientdata->fileslistvalid= 0;
+  pkg->clientdata->files= 0;
+}
+
+void cu_closepipe(int argc, void **argv) {
+  int *p1= (int*)argv[0];
+  close(p1[0]); close(p1[1]);
+}
+
+void cu_closefile(int argc, void **argv) {
+  FILE *f= (FILE*)(argv[0]);
+  fclose(f);
+}
+
+void cu_closedir(int argc, void **argv) {
+  DIR *d= (DIR*)(argv[0]);
+  closedir(d);
+}
+
+void cu_closefd(int argc, void **argv) {
+  int ip= *(int*)argv[0];
+  close(ip);
+}
+
+int ignore_depends(struct pkginfo *pkg) {
+  struct packageinlist *id;
+  for (id= ignoredependss; id; id= id->next)
+    if (id->pkg == pkg) return 1;
+  return 0;
+}
+
+int force_depends(struct deppossi *possi) {
+  return fc_depends ||
+         ignore_depends(possi->ed) ||
+         ignore_depends(possi->up->up);
+}
+
+int force_conflicts(struct deppossi *possi) {
+  return fc_conflicts;
+}
+
+const char *pkgadminfile(struct pkginfo *pkg, const char *whichfile) {
+  static struct varbuf vb;
+  varbufreset(&vb);
+  varbufaddstr(&vb,admindir);
+  varbufaddstr(&vb,"/" INFODIR);
+  varbufaddstr(&vb,pkg->name);
+  varbufaddc(&vb,'.');
+  varbufaddstr(&vb,whichfile);
+  varbufaddc(&vb,0);
+  return vb.buf;
+}
+
+static const char* preexecscript(const char *path, char *const *argv) {
+  /* returns the path to the script inside the chroot
+   * none of the stuff here will work if admindir isn't inside instdir
+   * as expected. - fixme
+   */
+  size_t instdirl;
+
+  if (*instdir) {
+    if (chroot(instdir)) ohshite(_("failed to chroot to `%.250s'"),instdir);
+  }
+  if (f_debug & dbg_scripts) {
+    fprintf(stderr,"D0%05o: fork/exec %s (",dbg_scripts,path);
+    while (*argv) fprintf(stderr," %s",*argv++);
+    fputs(" )\n",stderr);
+  }
+  instdirl= strlen(instdir);
+  if (!instdirl) return path;
+  assert (strlen(path)>=instdirl);
+  return path+instdirl;
+}  
+
+static char *const *vbuildarglist(const char *scriptname, va_list ap) {
+  static char *bufs[PKGSCRIPTMAXARGS+1];
+  char *nextarg;
+  int i;
+
+  i=0;
+  if(bufs[0]) free(bufs[0]);
+  bufs[i++]= strdup(scriptname); /* yes, cast away const because exec wants it that way */
+  for (;;) {
+    assert(i < PKGSCRIPTMAXARGS);
+    nextarg= va_arg(ap,char*);
+    if (!nextarg) break;
+    bufs[i++]= nextarg;
+  }
+  bufs[i]= 0;
+  return bufs;
+}    
+
+static char *const *buildarglist(const char *scriptname, ...) {
+  char *const *arglist;
+  va_list ap;
+  va_start(ap,scriptname);
+  arglist= vbuildarglist(scriptname,ap);
+  va_end(ap);
+  return arglist;
+}
+
+#define NSCRIPTCATCHSIGNALS (int)(sizeof(script_catchsignallist)/sizeof(int)-1)
+static int script_catchsignallist[]= { SIGQUIT, SIGINT, 0 };
+static struct sigaction script_uncatchsignal[NSCRIPTCATCHSIGNALS];
+
+static void cu_restorescriptsignals(int argc, void **argv) {
+  int i;
+  for (i=0; i<NSCRIPTCATCHSIGNALS; i++) {
+    if (sigaction(script_catchsignallist[i],&script_uncatchsignal[i],0)) {
+      fprintf(stderr,_("error un-catching signal %s: %s\n"),
+              strsignal(script_catchsignallist[i]),strerror(errno));
+      onerr_abort++;
+    }
+  }
+}
+
+static void script_catchsignals(void) {
+  int i;
+  struct sigaction catchsig;
+  
+  onerr_abort++;
+  memset(&catchsig,0,sizeof(catchsig));
+  catchsig.sa_handler= SIG_IGN;
+  sigemptyset(&catchsig.sa_mask);
+  catchsig.sa_flags= 0;
+  for (i=0; i<NSCRIPTCATCHSIGNALS; i++)
+    if (sigaction(script_catchsignallist[i],&catchsig,&script_uncatchsignal[i]))
+      ohshite(_("unable to ignore signal %s before running script"),
+              strsignal(script_catchsignallist[i]));
+  push_cleanup(cu_restorescriptsignals,~0, 0,0, 0);
+  onerr_abort--;
+}
+
+static void setexecute(const char *path, struct stat *stab) {
+  if ((stab->st_mode & 0555) == 0555) return;
+  if (!chmod(path,0755)) return;
+  ohshite(_("unable to set execute permissions on `%.250s'"),path);
+}
+static int do_script(const char *pkg, const char *scriptname, const char *scriptpath, struct stat *stab, char *const arglist[], const char *desc, const char *name, int warn) {
+  const char *scriptexec;
+  int c1, r;
+  setexecute(scriptpath,stab);
+
+  c1= m_fork();
+  if (!c1) {
+    const char **narglist;
+    for (r=0; arglist[r]; r++) ;
+    narglist=nfmalloc((r+1)*sizeof(char*));
+    for (r=1; arglist[r-1]; r++)
+      narglist[r]= arglist[r];
+    scriptexec= preexecscript(scriptpath,narglist);
+    narglist[0]= scriptexec;
+    execv(scriptexec,narglist);
+    ohshite(desc,name);
+  }
+  script_catchsignals(); /* This does a push_cleanup() */
+  r= waitsubproc(c1,name,warn);
+  pop_cleanup(ehflag_normaltidy);
+  return r;
+}
+
+int maintainer_script_installed(struct pkginfo *pkg, const char *scriptname,
+                                const char *description, ...) {
+  /* all ...'s are const char*'s */
+  const char *scriptpath;
+  char *const *arglist;
+  struct stat stab;
+  va_list ap;
+  char buf[100];
+
+  scriptpath= pkgadminfile(pkg,scriptname);
+  va_start(ap,description);
+  arglist= vbuildarglist(scriptname,ap);
+  va_end(ap);
+  sprintf(buf,"%s script",description);
+
+  if (stat(scriptpath,&stab)) {
+    if (errno == ENOENT) {
+      debug(dbg_scripts,"maintainer_script_installed nonexistent %s",scriptname);
+      return 0;
+    }
+    ohshite(_("unable to stat installed %s script `%.250s'"),description,scriptpath);
+  }
+  do_script(pkg->name, scriptname, scriptpath, &stab, arglist, _("unable to execute %s"), buf, 0);
+  ensure_diversions();
+  return 1;
+}
+  
+int maintainer_script_new(const char *pkgname,
+			  const char *scriptname, const char *description,
+                          const char *cidir, char *cidirrest, ...) {
+  char *const *arglist;
+  struct stat stab;
+  va_list ap;
+  char buf[100];
+  
+  va_start(ap,cidirrest);
+  arglist= vbuildarglist(scriptname,ap);
+  va_end(ap);
+  sprintf(buf,"%s script",description);
+
+  strcpy(cidirrest,scriptname);
+  if (stat(cidir,&stab)) {
+    if (errno == ENOENT) {
+      debug(dbg_scripts,"maintainer_script_new nonexistent %s `%s'",scriptname,cidir);
+      return 0;
+    }
+    ohshite(_("unable to stat new %s script `%.250s'"),description,cidir);
+  }
+  do_script(pkgname, scriptname, cidir, &stab, arglist, _("unable to execute new %s"), buf, 0);
+  ensure_diversions();
+  return 1;
+}
+
+int maintainer_script_alternative(struct pkginfo *pkg,
+                                  const char *scriptname, const char *description,
+                                  const char *cidir, char *cidirrest,
+                                  const char *ifok, const char *iffallback) {
+  const char *oldscriptpath;
+  char *const *arglist;
+  struct stat stab;
+  char buf[100];
+
+  oldscriptpath= pkgadminfile(pkg,scriptname);
+  arglist= buildarglist(scriptname,
+                        ifok,versiondescribe(&pkg->available.version,
+                                             vdew_nonambig),
+                        (char*)0);
+  sprintf(buf,_("old %s script"),description);
+  if (stat(oldscriptpath,&stab)) {
+    if (errno == ENOENT) {
+      debug(dbg_scripts,"maintainer_script_alternative nonexistent %s `%s'",
+            scriptname,oldscriptpath);
+      return 0;
+    }
+    fprintf(stderr,
+            _("dpkg: warning - unable to stat %s `%.250s': %s\n"),
+            buf,oldscriptpath,strerror(errno));
+  } else {
+    if (!do_script(pkg->name, scriptname, oldscriptpath, &stab, arglist, _("unable to execute %s"), buf, PROCWARN))
+      return 1;
+    ensure_diversions();
+  }
+  fprintf(stderr, _("dpkg - trying script from the new package instead ...\n"));
+
+  arglist= buildarglist(scriptname,
+                        iffallback,versiondescribe(&pkg->installed.version,
+                                                   vdew_nonambig),
+                        (char*)0);
+  strcpy(cidirrest,scriptname);
+  sprintf(buf,_("new %s script"),description);
+
+  if (stat(cidir,&stab)) {
+    if (errno == ENOENT)
+      ohshit(_("there is no script in the new version of the package - giving up"));
+    else
+      ohshite(_("unable to stat %s `%.250s'"),buf,cidir);
+  }
+
+  do_script(pkg->name, scriptname, cidir, &stab, arglist, _("unable to execute %s"), buf, 0);
+  fprintf(stderr, _("dpkg: ... it looks like that went OK.\n"));
+
+  ensure_diversions();
+  return 1;
+}
+
+void clear_istobes(void) {
+  struct pkgiterator *it;
+  struct pkginfo *pkg;
+
+  it= iterpkgstart();
+  while ((pkg= iterpkgnext(it)) != 0) {
+    ensure_package_clientdata(pkg);
+    pkg->clientdata->istobe= itb_normal;
+    pkg->clientdata->replacingfilesandsaid= 0;
+  }
+}
+
+void debug(int which, const char *fmt, ...) {
+  va_list ap;
+  if (!(f_debug & which)) return;
+  fprintf(stderr,"D0%05o: ",which);
+  va_start(ap,fmt);
+  vfprintf(stderr,fmt,ap);
+  va_end(ap);
+  putc('\n',stderr);
+}
+
+int isdirectoryinuse(struct filenamenode *file, struct pkginfo *pkg) {
+  /* Returns 1 if the file is used by packages other than pkg, 0 otherwise. */
+  struct filepackages *packageslump;
+  int i;
+    
+  debug(dbg_veryverbose, "isdirectoryinuse `%s' (except %s)", file->name,
+        pkg ? pkg->name : "<none>");
+
+  /* FINK LOCAL begin */
+
+  /*
+   * Darwin has symlinks /etc -> /private/etc and /var -> /private/var
+   * instead of actual /etc and /var dirs. If dpkg removes the last
+   * pkg that it has record of having installed a file in one of those
+   * top-level dirs, it will try to remove the dir (since it thinks
+   * it's an empty dir) and it will succeed (since it's just unlinking
+   * a symlink, not trying to remove a dir that is not actually
+   * empty). That's Bad. Here we make sure these top-level dirs are
+   * never thought to be empty.
+   */
+  if( !strcmp(file->name,"/etc") || !strcmp(file->name,"/tmp") || !strcmp(file->name,"/var") ) {
+    debug(dbg_veryverbose, "isdirectoryinuse precious!");
+    return 1;
+  }
+
+  /* FINK LOCAL end */
+
+  for (packageslump= file->packages; packageslump; packageslump= packageslump->more) {
+    debug(dbg_veryverbose, "isdirectoryinuse packageslump %s ...",
+          packageslump->pkgs[0] ? packageslump->pkgs[0]->name : "<none>");
+    for (i=0; i < PERFILEPACKAGESLUMP && packageslump->pkgs[i]; i++) {
+      debug(dbg_veryverbose, "isdirectoryinuse considering [%d] %s ...", i,
+            packageslump->pkgs[i]->name);
+      if (packageslump->pkgs[i] == pkg) continue;
+      return 1;
+    }
+  }
+  debug(dbg_veryverbose, "isdirectoryinuse no");
+  return 0;
+}
+
+void oldconffsetflags(const struct conffile *searchconff) {
+  struct filenamenode *namenode;
+  
+  while (searchconff) {
+    namenode= findnamenode(searchconff->name, 0); /* XXX */
+    namenode->flags |= fnnf_old_conff;
+    debug(dbg_conffdetail, "oldconffsetflags `%s' namenode %p flags %o",
+          searchconff->name, namenode, namenode->flags);
+    searchconff= searchconff->next;
+  }
+}
+
+int chmodsafe_unlink(const char *pathname) {
+  struct stat stab;
+
+  if (lstat(pathname,&stab)) return -1;
+  if (S_ISREG(stab.st_mode) ? (stab.st_mode & 07000) :
+      !(S_ISLNK(stab.st_mode) || S_ISDIR(stab.st_mode) ||
+   S_ISFIFO(stab.st_mode) || S_ISSOCK(stab.st_mode))) {
+    /* We chmod it if it is 1. a sticky or set-id file, or 2. an unrecognised
+     * object (ie, not a file, link, directory, fifo or socket
+     */
+    if (chmod(pathname,0600)) return -1;
+  }
+  if (unlink(pathname)) return -1;
+  return 0;
+}
+
+void ensure_pathname_nonexisting(const char *pathname) {
+  int c1;
+  const char *u;
+
+  u= skip_slash_dotslash(pathname);
+  assert(*u);
+
+  debug(dbg_eachfile,"ensure_pathname_nonexisting `%s'",pathname);
+  if (!rmdir(pathname)) return; /* Deleted it OK, it was a directory. */
+  if (errno == ENOENT || errno == ELOOP) return;
+  if (errno == ENOTDIR) {
+    /* Either it's a file, or one of the path components is.  If one
+     * of the path components is this will fail again ...
+     */
+    if (!chmodsafe_unlink(pathname)) return; /* OK, it was */
+    if (errno == ENOTDIR) return;
+  }
+  if (errno != ENOTEMPTY) /* Huh ? */
+    ohshite(_("failed to rmdir/unlink `%.255s'"),pathname);
+  c1= m_fork();
+  if (!c1) {
+    execlp(RM,"rm","-rf","--",pathname,(char*)0);
+    ohshite(_("failed to exec rm for cleanup"));
+  }
+  debug(dbg_eachfile,"ensure_pathname_nonexisting running rm -rf");
+  waitsubproc(c1,"rm cleanup",0);
+}
